

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>&lt;no title&gt; &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>&lt;no title&gt;</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/api/posydon.grids.downsampling.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <span class="target" id="module-posydon.grids.downsampling"></span><p>Module for downsampling accross a path in multi-dimensional space.</p>
<p>Let a d-dimensional parametric curve in of the form:</p>
<blockquote>
<div><p>x_1 = x_1(t)
x_2 = x_2(t)
…
x_d = x_d(t)</p>
</div></blockquote>
<p>sampled at N time steps, t_1, t_2, …, t_N. It is possible to select a subset
of the time steps - essentially defining a downsampled version of the curve -
so that the original curve can be reconstructed with minimum error.</p>
<p>The provided class <cite>TrackDownsampler</cite> performs the downsampling. It requires
two input arrays. The first is the “independent” variable, t, which does not
have to be temporal (e.g., spatial), but must be strictly increasing. The 2nd
array is the track, in which the different columns correspond to the different
dimensions:</p>
<blockquote>
<div><blockquote>
<div><p>— parameters —&gt;</p>
</div></blockquote>
<div class="line-block">
<div class="line">x_1(t_1)    x_2(t_1)    …     x_d(t_1)</div>
</div>
</div></blockquote>
<dl>
<dt>time    x_1(t_2)    x_2(t_2)    …     x_d(t_2)</dt><dd><p>or         .           .       …         .
any        .           .       …         .</p>
<blockquote>
<div><div class="line-block">
<div class="line">.           .       …         .</div>
</div>
<p>V     x_1(t_N)    x_2(t_N)    …     x_d(t_N)</p>
</div></blockquote>
<p>TD = TrackDownsample(t, X)
t_new, X_new = TD.downsample(max_err=0.001)</p>
</dd>
</dl>
<dl class="py class">
<dt id="posydon.grids.downsampling.TrackDownsampler">
<em class="property">class </em><code class="sig-prename descclassname">posydon.grids.downsampling.</code><code class="sig-name descname">TrackDownsampler</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">independent</span></em>, <em class="sig-param"><span class="n">dependent</span></em>, <em class="sig-param"><span class="n">verbose</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.9)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
<p>Class performing downsampling of multi-dimensional paths.</p>
<p>Get, reduce and rescale data.</p>
<dl class="py method">
<dt id="posydon.grids.downsampling.TrackDownsampler.downsample">
<code class="sig-name descname">downsample</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">max_err</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">scale_back</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler.downsample"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler.downsample" title="Permalink to this definition">¶</a></dt>
<dd><p>Perform the downsampling and return the result.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.grids.downsampling.TrackDownsampler.extract_downsample">
<code class="sig-name descname">extract_downsample</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">scale_back</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler.extract_downsample"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler.extract_downsample" title="Permalink to this definition">¶</a></dt>
<dd><p>Extract the downsampled array.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.grids.downsampling.TrackDownsampler.find_downsample">
<code class="sig-name descname">find_downsample</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">max_err</span><span class="o">=</span><span class="default_value">None</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler.find_downsample"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler.find_downsample" title="Permalink to this definition">¶</a></dt>
<dd><p>Find the rows of the data that constitute the “down-sample”.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.grids.downsampling.TrackDownsampler.rescale">
<code class="sig-name descname">rescale</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler.rescale"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler.rescale" title="Permalink to this definition">¶</a></dt>
<dd><p>Rescale the parameter space from 0 to 1.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.grids.downsampling.TrackDownsampler.say">
<code class="sig-name descname">say</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">message</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#TrackDownsampler.say"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.TrackDownsampler.say" title="Permalink to this definition">¶</a></dt>
<dd><p>Speak to the standard output, only if <cite>.verbose</cite> is False.</p>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt id="posydon.grids.downsampling.rescale_from_0_to_1">
<code class="sig-prename descclassname">posydon.grids.downsampling.</code><code class="sig-name descname">rescale_from_0_to_1</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">array</span></em>, <em class="sig-param"><span class="n">return_minmax</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/grids/downsampling.html#rescale_from_0_to_1"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.grids.downsampling.rescale_from_0_to_1" title="Permalink to this definition">¶</a></dt>
<dd><p>Rescale a matrix so that all dimensions span from 0 to 1.</p>
</dd></dl>



           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>